function[SE_5perc,user_throughput] = Calc5thrate_noUAV(Xm, Ym, Zm, Xue, Yue, Pm,gain)

All_Node_Coor = [Xm Ym Zm ones(size(Xm))];
    Zue=.002; % 2 meter UE height
    % Find distances between every UE from every BS
    [Xue_mat, Xm_mat] = ndgrid(Xue, All_Node_Coor(:,1));
    [Yue_mat, Ym_mat] = ndgrid(Yue, All_Node_Coor(:,2));
    [Zue_mat, Zm_mat] = ndgrid(Zue, All_Node_Coor(:,3));
    Dmpu = sqrt((Xm_mat-Xue_mat).^2 + (Ym_mat-Yue_mat).^2 + (Zm_mat-Zue_mat).^2);
    clear Xue_mat Yue_mat Zue_mat Xm_mat Ym_mat Zm_mat
    
    % Find MOI for every UE
    [~,idx_moi] = min(Dmpu,[],2);
    %idx_moi_thr=idx_moi;
	antenna_gain_ue=10.^(gain./10);
	Pr=[Pm*ones(length(Xue),length(Xm))]./(10.^((hata_nouav(Zm,Dmpu)./10)));
    % find received powers from MOI for each UE
    %Pr_mac = Pr(sub2ind(size(Pr),(1:length(idx_moi))',idx_moi));
    %Pr_uav = Pr(sub2ind(size(Pr),(1:length(idx_uoi))',idx_uoi));

   % find received power from MOI for each UE
    Pr=antenna_gain_ue.*Pr; 
    Pr_mac = Pr(sub2ind(size(Pr),(1:length(idx_moi))',idx_moi));
    
    % Calculate total interference at each UE
    Z = sum(Pr,2) - Pr_mac;

    % Calculte Macro and pico SIRs
    SIR_mac = Pr_mac./Z;


    % Assuming round-robin scheduling, calculate the SEs of all the UEs
    % MUEs
    moi_list = tabulate([-1; idx_moi]);
    moi_list(1,:) = [];
    N_mue = moi_list(:,2);
    moi_list = moi_list(:,1);
    SE = zeros(size(SIR_mac));
    for x = 1:length(moi_list)
        idx = idx_moi == moi_list(x);
        SE(idx) = log2(1+SIR_mac(idx))/N_mue(x);
    end

     % Calculate 5th percentile SE
    [SE_CDF, SE_x] = cdfcalc(SE);
    IdxLower = find(SE_CDF <= 0.05,1,'last');
    IdxHigher = find(SE_CDF >= 0.05,1,'first');
    if((SE_CDF(IdxHigher)-0.05) < (0.05-SE_CDF(IdxLower)))
        SE_5perc = SE_x(IdxHigher);
    else
        SE_5perc = SE_x(IdxLower);
    end
    
    user_throughput=SE;
    size(SE);
   % SE_total=sum(SE);
    %proportional_fair_throughput=SE_total;
    %proportional_fair_throughput=SE;
end

