function y=dynamic_3D(A,T_max,start_point_trans,end_point_trans,Zuav)
%dbstop if error
direction_2D=[0 0 ;-1 0 ;0 -1 ;1 -1 ;0 1 ;1 0 ;1 1 ; -1 -1 ;-1 1 ];
heightRange=Zuav(2)-Zuav(1);
%% Creating 3D directions
direction_3D_cell={size(direction_2D,1)};
direction_3D=zeros(size(direction_2D,1)*(2*length(Zuav)-1),3);
kk=1;
for i=1:size(direction_2D,1)
    AA=direction_2D(i,:);
    BB=repmat(AA,(2*length(Zuav)-1),1);
    CC=[BB heightRange*(-length(Zuav)+1:length(Zuav)-1)'];
    direction_3D_cell{i}=CC;
    direction_3D(kk:kk+(2*length(Zuav)-2),:)=CC;
    kk=kk+(2*length(Zuav)-1);
end

%% Creating cost matrix and adjacency matrix
anyNegativeA = any(A(:)<0);
if anyNegativeA==1
    pf=-1*A;
else
    pf=1./A;
end
size_grid=size(pf,1);
nodes=pf(:);
Adjacency=zeros(length(nodes));
cost_matrix=zeros(length(nodes));
for i=1:length(nodes)
     neighbor_points=zeros(length(direction_3D),3); % index of the cost function not real valued positions
     [ix,iy,iz]=ind2sub(size(pf),i);
     current_point=[ix,iy,Zuav(iz)];
    for n=1:length(direction_3D)
         neighbor_points(n,:)=current_point+direction_3D(n,:);
         neighborX =neighbor_points(n,1);
         neighborY =neighbor_points(n,2);
         neighborZ =neighbor_points(n,3);
         
         if(neighborX >=1 && neighborX <=size_grid && neighborY >=1 && neighborY <=size_grid &&  neighborZ >=Zuav(1) && neighborZ <=Zuav(end))
               kk=find(abs(Zuav-neighborZ)<.0001);
               cost=min(pf(neighborX,neighborY,kk));
              % disp( neighbor_points(n,:))
               neighbor_interst=find(pf==cost);
               Adjacency(i,neighbor_interst)=1; % node index of possible moves from a certain state
               cost_matrix(i,neighbor_interst)=cost; % cost matrix to run dynamic programming
         end
        
    end
end
% Save the index of neighbours not itself in a matrix
neibors_of_nodes=Adjacency;
for i=1:length(Adjacency)
    for j=1:length(Adjacency)
        if i==j
          neibors_of_nodes(i,j)=0;
        end
    end
end

%A2=permute(reshape(cost_matrix, 13, 3, 13), [1, 3, 2]);
%% Main Dynamic Programming
% 1. Initialization
J=Inf*ones(T_max-1,length(nodes));
end_index = sub2ind(size(pf),end_point_trans(1),end_point_trans(2),1);
no_of_node=1:length(pf(:));
C=no_of_node;
%no_of_node(end_index)=[];
%B=cost_matrix;

k=find(neibors_of_nodes(end_index,:)==1); % find the neighbour of the end points
for i=1:length(k)
    J(T_max-1,k(i))=cost_matrix(end_index,k(i)); % initialize the neighbour node costs of end point
end
%cost_matrix(end_index,:)=0; % reason to delete it????


% 2. Recursion using Bellman backward induction
for t=T_max-2:-1:1
    for i=1:length(C)
     % if no_of_node(i)~=end_index
       current_node=no_of_node(i);
       %disp(current_node)
       [x,y,z] = ind2sub(size(pf),current_node);
        b=pf(x,y,z);
       k=find(cost_matrix(current_node,:)~=0);
       cost=[];
       for j=1:length(k)
           %if k(j)~=end_index
               a=J(t+1,k(j));
               cost(j)=a+b;
           %end
       end
       [val,id]=min(cost);
       J(t,current_node)=val;    %Optimum go-to-cost calculation 
       if val==Inf
           u(t,current_node)=0;
       else
         u(t,current_node)=k(id);% Optimum Policy vector calculation
       end
     % end
    end
  %J(t,:)  
end
%% Trajectory or optimum Policy Calculation at each time instance
start_index=sub2ind(size(pf),start_point_trans(1),start_point_trans(2),1);
current_point=start_index;
%traject=zeros(length(u),1);
%u(:,end_index)=[]
for i=1:size(u,1)
  traject(i,1)=u(i,current_point);
  current_point=traject(i,1);
end
traject=[start_index;traject;end_index];
%% Node to matrix index for optimal policy
Trajectory_optimal=zeros(length(traject),3);
for i=1:length(traject)
    [x,y,z]=ind2sub(size(pf),traject(i,1));
    Trajectory_optimal(i,:)=[x y z];
end
y=Trajectory_optimal;
% x1=y(1:length(y));
% y1=y(length(y)+1:end);
% plot(x1,y1)
% xlim([1 30]);
% ylim([1 30])
end