clc
close all
clear all

path2='C:\PhD Research\3D Trajectory Research\IEEE Transaction on Aerospace\SE Gain Calculation\MBS_4';
addpath(path2)
path1='C:\PhD Research\3D Trajectory Research\IEEE Transaction on Aerospace\SE Gain Calculation\MBS_4\T_30';
addpath(path1)
grid_size=.1;
b = 1;
Res =-.1:grid_size:b+.1;  
K_dB            = 0;         % Attenuation due to geometrical parameters of antennas (in dB)
HeightMBS       = 0.030;    % Height of the MBSs (in km)
HeightUAV1       = 0.12;      % Height of the UAVs (in km)
P_mac_dBm       = 46;        %Macro Tx power (in dBm)
P_uav_dBm       = 30;          % UAV Tx power (in dBm)
Pm = 10^(P_mac_dBm/10)/1000 * 10^(K_dB/10); % Net transmit power in Watts
Puav = 10.^(P_uav_dBm/10)/1000* 10^(K_dB/10); % Net transmit power in Watts
PLE=3;
tc=0.05;
for ii=1:100
    
Traject_max_sum_3D =(cell2mat(struct2cell(load(['Traject_backhaul_3D_antenna_max_'  num2str(ii) '.mat']))));
Traject_max_sum_2D_40  =(cell2mat(struct2cell(load(['Traject_backhaul_2D_antenna_max_40_'  num2str(ii) '.mat']))));
Traject_max_sum_2D_80  =(cell2mat(struct2cell(load(['Traject_backhaul_2D_antenna_max_80_'  num2str(ii) '.mat']))));
Traject_max_sum_2D_120  =(cell2mat(struct2cell(load(['Traject_backhaul_2D_antenna_max_120_'  num2str(ii) '.mat']))));
Network=load(['Network_' num2str(ii) '.mat']);
Xm=Network.xm;Ym=Network.ym;Xue=Network.xue;Yue=Network.yue;
Zm = HeightMBS*ones(size(Xm));Zue=.002*ones(size(Xue));
[elev,azi]=angle_calculation(Xm,Ym,Zm,Xue,Yue,Zue);
dbstop if error
%% Antenna Gain vector
theta_s=6; % 12 degree electrical downtilt
phi_s=0;
gain_vector=zeros(1,length(Xue)*length(Xm));

elev=elev(:);azi=azi(:);
 for i=1:length(gain_vector)
    [gain_vector(i),~]=radiation_rebato(elev(i),azi(i),theta_s);
 end
%disp(gain_vector)
gain_vector=reshape(gain_vector,length(Xue),length(Xm));
%% Results with No UAV to campare with UAV deployment
max_noUAV=(maxsumrate_noUAV(Xm, Ym, Zm, Xue, Yue, Pm,gain_vector));

for i=-.1:grid_size:Res(end)
        for j=-.1:grid_size:Res(end)
            %if  (~(i==start_point_trans(1) && j==start_point_trans(2)))
            %point_current=[i,j];
            nx=trans(i);
            ny=trans(j);
            %for k=1:length(Zuav)  
                 max_throughput_harmonic_antenna(nx,ny)=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue,Zue, Pm, i,j , Zuav, Puav,gain_vector,theta_s); 
                %max_throughput_harmonic_antenna(nx,ny)=sum(a);
                %max_throughput_harmonic_antenna(nx,ny,k)= maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue,Zue, Pm, i,j , Zuav(k), Puav,gain_vector);              
            %end
        end
end
for i=1:size(Traject_max_sum_3D,1)
    % Calculationg Throughput of each UE using both Trajectories
   [ ~,user_max_sum_3D]=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue, Pm, PLE, Traject_max_sum_3D(i,1),Traject_max_sum_3D(i,2), Traject_max_sum_3D(i,3), Puav,gain_vector,theta_s);
   [ ~,user_max_sum_2D_40]=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue, Pm, PLE, Traject_max_sum_2D_40(i,1),Traject_max_sum_2D_40(i,2), 0.04, Puav,gain_vector,theta_s);
   [ ~,user_max_sum_2D_80]=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue, Pm, PLE, Traject_max_sum_2D_80(i,1),Traject_max_sum_2D_80(i,2), 0.08, Puav,gain_vector,theta_s);
   [ ~,user_max_sum_2D_120]=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue, Pm, PLE, Traject_max_sum_2D_120(i,1),Traject_max_sum_2D_120(i,2), 0.12, Puav,gain_vector,theta_s);
   % Calculating Jain's Fairness Index and Total Throughput
    outage_max_idx_3D=find(user_max_sum_3D<tc);
    outage_max_3D(i)=length(outage_max_idx_3D)/length(Xue); 
    
    outage_max_idx_2D_40=find(user_max_sum_2D_40<tc);
    outage_max_2D_40(i)=length(outage_max_idx_2D_40)/length(Xue);
    
    outage_max_idx_2D_80=find(user_max_sum_2D_80<tc);
    outage_max_2D_80(i)=length(outage_max_idx_2D_80)/length(Xue);
    
    outage_max_idx_2D_120=find(user_max_sum_2D_120<tc);
    outage_max_2D_120(i)=length(outage_max_idx_2D_120)/length(Xue);
    
end
%% Results with No UAV to campare with UAV deployment
[~,user_maxnoUAV]=(maxsumrate_noUAV(Xm, Ym, Zm, Xue, Yue, Pm,gain_vector));
%[PF_noUAV,user_PFnoUAV]=(PFrate_noUAV(Xm, Ym, Zm, Xue, Yue, Pm,gain_vector));
outage_noUAV_idx=find(user_maxnoUAV<tc);
outage_noUAV(ii)=length(outage_noUAV_idx)/length(Xue);

outage_max_avg_3D(ii)=mean(outage_max_3D);
outage_max_avg_2D_40(ii)=mean(outage_max_2D_40);
outage_max_avg_2D_80(ii)=mean(outage_max_2D_80);
outage_max_avg_2D_120(ii)=mean(outage_max_2D_120);

end
%% Averaging over 20 instances

    
