function [elev,azim]=angle_calculation(Xm,Ym,Zm,Xue,Yue,Zue,Xuav,Yuav,Zuav)
%%%%%%%%%%%%%%%%%%%%%%%%%%%  Case without UAV   %%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin==6
%% UE Angle Calculation Part
  % Coordinates of all the MBS and UAV nodes (the third column
    All_Node_Coor = [Xm Ym Zm ones(size(Xm))];

    % Find distances between every UE from every MBS and UAV
    [Xue_mat, Xmu_mat] = ndgrid(Xue, All_Node_Coor(:,1));
    [Yue_mat, Ymu_mat] = ndgrid(Yue, All_Node_Coor(:,2));
    [Zue_mat, Zmu_mat] = ndgrid(.002*ones(size(Xue)), All_Node_Coor(:,3)); % check this
    Dmu = sqrt((Xmu_mat-Xue_mat).^2 + (Ymu_mat-Yue_mat).^2 + 0*(Zmu_mat-Zue_mat).^2); %% For angle only 2D distance is necessary 


    % Find MOI and UOI for every UE
    %[~, idx_moi] = min(Dmu(:,1:length(Xm)),[],2);
    %% Elevation and Azimuthal Angle Calculation
    azm=zeros(length(Xue),length(Xm));
    elev=azm;
    for i=1:length(Xue)
        for j=1:length(Xm)
        azm(i,j) = getAngle([Xm(j),Ym(j)],[Xue(i),Yue(i)]);
        two_D_dist=Dmu(i,j);
        elev(i,j)=180-atand(two_D_dist/abs(Zm(1)-Zue(1))); 
        end
    end
    azim=mod(azm,60);
    
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%  Case with UAV   %%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin==9
%% UAV Angle Calculation Part
     % Coordinates of all the MBS and UAV nodes (the third column
    All_Node_Coor = [Xm Ym Zm ones(size(Xm))];

    % Find distances between every UE from every MBS and UAV
    [Xue_mat, Xmu_mat] = ndgrid(Xuav, All_Node_Coor(:,1));
    [Yue_mat, Ymu_mat] = ndgrid(Yuav, All_Node_Coor(:,2));
    [Zue_mat, Zmu_mat] = ndgrid(Zuav, All_Node_Coor(:,3)); % check this
    Dmuav = sqrt((Xmu_mat-Xue_mat).^2 + (Ymu_mat-Yue_mat).^2 + 0*(Zmu_mat-Zue_mat).^2); %% For angle only 2D distance is necessary 

%     % Find MOI and UOI for every UE
%     [~, idx_moi] = min(Dmu(:,1:length(Xm)),[],2);
%     Dmuav=sqrt((Xuav-Xm(idx_moi)).^2+(Yuav-Ym(idx_moi)).^2);
    %% Azimuthal Angle Calculation
    for i=1:length(Xm)
       elev(i)=atand( Dmuav(i)/abs(Zm(1)-Zuav)); 
       azm(i) = getAngle([Xm(i),Ym(i)],[Xuav,Yuav]);
    end
    azim=mod(azm,60);
% azm = (azimuth(X(1),X(2),Y(1),Y(2)));
% azim=mod(azm,120);
% 
% %% Elevation Angle Calculation
% two_D_dist=norm(X-Y);
% if Z2>Z1
%     elev=-90+atand(two_D_dist/abs(Z1-Z2));
% else
%     elev=atand(two_D_dist/abs(Z1-Z2));
% end
end
end