function y=dynamic2(A,T_max,start_point_trans,end_point_trans)
direction=[0 0;-1 0;0 -1;1 -1;0 1;1 0;1 1; -1 -1;-1 1];
anyNegativeA = any(A(:)<0);
if anyNegativeA==1
    pf=-1*A;
else
    pf=1./A;
end
size_grid=length(pf);
nodes=pf(:);
Adjacency=zeros(length(nodes));
cost_matrix=zeros(length(nodes));
for i=1:length(nodes)
     neighbor_points=zeros(length(direction),2); 
     [ix,iy]=ind2sub(size(pf),i);
     current_point=[ix,iy];
    for n=1:length(direction)
         neighbor_points(n,:)=current_point+direction(n,:);
         neighborX =neighbor_points(n,1);
         neighborY =neighbor_points(n,2);
         
         if(neighborX >=1 && neighborX <=size_grid && neighborY >=1 && neighborY <=size_grid)
               
               cost=pf(neighborX,neighborY);
              % disp( neighbor_points(n,:))
               neighbor_interst=find(pf==cost);
               Adjacency(i,neighbor_interst)=1; % node index of possible moves from a certain state
               cost_matrix(i,neighbor_interst)=cost; % cost matrix to run dynamic programming
         end
        
    end
end
% Save the index of neighbours not itself in a matrix
neibors_of_nodes=Adjacency;
for i=1:length(Adjacency)
    for j=1:length(Adjacency)
        if i==j
          neibors_of_nodes(i,j)=0;
        end
    end
end
%% Main Dynamic Programming
% 1. Initialization
J=Inf*ones(T_max-1,length(nodes));
end_index = sub2ind(size(pf),end_point_trans(1),end_point_trans(2));
no_of_node=1:length(pf(:));
C=no_of_node;
%no_of_node(end_index)=[];
B=cost_matrix;

k=find(neibors_of_nodes(end_index,:)==1); % find the neighbour of the end points
for i=1:length(k)
    J(T_max-1,k(i))=cost_matrix(end_index,k(i)); % initialize the neighbour node costs of end point
end
%cost_matrix(end_index,:)=0; % reason to delete it????


% 2. Recursion using Bellman backward induction
for t=T_max-2:-1:1
    for i=length(C):-1:1
     % if no_of_node(i)~=end_index
       current_node=no_of_node(i);
       %disp(current_node)
       [x,y] = ind2sub(size(pf),current_node);
        b=pf(x,y);
       k=find(cost_matrix(current_node,:)~=0);
       cost=[];
       for j=1:length(k)
           %if k(j)~=end_index
               a=J(t+1,k(j));
               cost(j)=a+b;
           %end
       end
       [val,id]=min(cost);
       J(t,current_node)=val;    %Optimum go-to-cost calculation 
       if val==Inf
           u(t,current_node)=0;
       else
         u(t,current_node)=k(id);% Optimum Policy vector calculation
       end
     % end
    end
  %J(t,:)  
end
%% Trajectory or optimum Policy Calculation at each time instance
start_index=sub2ind(size(pf),start_point_trans(1),start_point_trans(2));
current_point=start_index;
%traject=zeros(length(u),1);
%u(:,end_index)=[]
for i=1:size(u,1)
  traject(i,1)=u(i,current_point);
  current_point=traject(i,1);
end
traject=[start_index;traject;end_index];
%% Node to matrix index for optimal policy
Trajectory_optimal=zeros(length(traject),2);
for i=1:length(traject)
    [x,y]=ind2sub(size(pf),traject(i,1));
    Trajectory_optimal(i,:)=[x y];
end
y=Trajectory_optimal;
% x1=y(1:length(y));
% y1=y(length(y)+1:end);
% plot(x1,y1)
% xlim([1 30]);
% ylim([1 30])
end