function [max_sumrate,user_throughput] = maxsum_throughput_harmonic(Xmbs, Ymbs, Zmbs, Xue, Yue, Zue,Pm, Xuav, Yuav, Zuav_3d, Puav,gain,theta_s)

 
    % Coordinates of all the MBS and UAV nodes (the third column
    % indicates whether it is MBS (:1) or UAV (:2) )
    All_Node_Coor = [Xmbs Ymbs Zmbs ones(size(Xmbs)); Xuav Yuav Zuav_3d 2*ones(size(Xuav))];

    % Find distances between every UE from every MBS and UAV
    [Xue_mat, Xmu_mat] = ndgrid(Xue, All_Node_Coor(:,1));
    [Yue_mat, Ymu_mat] = ndgrid(Yue, All_Node_Coor(:,2));
    [Zue_mat, Zmu_mat] = ndgrid(Zue, All_Node_Coor(:,3)); % check this
    Dmu = sqrt((Xmu_mat-Xue_mat).^2 + (Ymu_mat-Yue_mat).^2 + (Zmu_mat-Zue_mat).^2);

    % Find MOI and UOI for every UE
    [~, idx_moi] = min(Dmu(:,1:length(Xmbs)),[],2);
    [~, idx_uoi] = min(Dmu(:,length(Xmbs)+1:end),[],2);
    idx_uoi = idx_uoi + length(Xmbs);
    idx_moi_thr=idx_moi;

    
    % Calculte Received powers at all the UEs from every MBS assuming
    % only the large-scale path-loss (No Rayleigh fading)
   % Pr = [Pm*ones(length(Xue),length(Xm)) Puav*ones(length(Xue),length(Xuav))]./(Dmu*1e3).^PLE; % free space
   %% Antenna Radiation Part
  % d=sqrt((Xuav-Xue).^2+(Yuav-Yue).^2);
  % antenna_radiation=cos(atan((Zuav-.002)./d)).^2; % Elevation Angle Calculation
   [elev_uav,azi_uav]=angle_calculation(Xmbs,Ymbs,Zmbs,Xue,Yue,Zue,Xuav,Yuav,Zuav_3d);
   antenna_gain_uav_dB=zeros(1,length(Xmbs));
   for i=1:length(Xmbs)
    [antenna_gain_uav_dB(i),~]=radiation_rebato(elev_uav(i),azi_uav(i),theta_s);
   end
   antenna_gain_uav=10.^((antenna_gain_uav_dB)./10);
  % antenna_gain_uav=1;
   antenna_gain_ue=10.^(gain./10);
   %% Realistic Path Loss Models 
    dist_mbs_uav=sqrt((Xuav-Xmbs).^2+(Yuav-Ymbs).^2+(Zuav_3d-Zmbs).^2);
    pl_mbs_uav=max(23.9-1.8*log10(Zuav_3d*1000),20)*log10(dist_mbs_uav*1000)+20*log10(40*pi*1.5/3); %PL model from 3GPP 1.5 is carrier frequency in GHz
%    %dist_uav_ue=sqrt((Xuav-Xue).^2+(Yuav-Yue).^2+(Zuav-.002).^2);
    dist_uav_ue=Dmu(:,end);
    pl_uav_ue=(mahdi_pl(dist_uav_ue))';
%    %pl_uav_ue=34.446+10*2.4*log10(dist_uav_ue*1000)+ normrnd(0,5.3,size(Xue));% 5.3 is the STD of Shadowing from Wahab's Paper
%    %pr_uav_ue=Puav*(Zuav*1000)^2*2^2./((dist_uav_ue*1000).^4);
    pr_mbs_uav=antenna_gain_uav'.*Pm.*ones(length(Xmbs),1)./10.^(pl_mbs_uav./10);
    pr_uav_ue=Puav*ones(length(Xue),1).*(pl_uav_ue);
   %% Hata model for Path loss for MBS to UAV direct connection
    
%
   Pr=[Pm*ones(length(Xue),length(Xmbs)) Puav.*ones(length(Xue),length(Xuav))]./(10.^((hata(Zmbs,Zuav_3d,Dmu)./10)));
    % find received powers from MOI for each UE
    Pr_antenna=antenna_gain_ue.*Pr(:,1:length(Xmbs));
    [~, idx_moi] = max(Pr_antenna,[],2);
    Pr_mac = Pr_antenna(sub2ind(size(Pr_antenna),(1:length(idx_moi))',idx_moi));
    %Pr_uav = Pr(sub2ind(size(Pr),(1:length(idx_uoi))',idx_uoi));
    Pr_uav=pr_uav_ue;
    % for each UE calculate the Rx power in the first hop
    Pr_mbs_uav=zeros(length(Xue),1);
    for i=1:length(Xue)
        Pr_mbs_uav(i,1)=pr_mbs_uav(idx_moi(i));
    end
%     if length(aaa)<1
%        Pr_uav=0*Pr_uav;  
%        Pr_mbs_uav= Pr_uav;
%     end
    Pr=vertcat([Pr_antenna Pr_uav]);
    %% Calculate total interference at each UE except MOI/UOI
    Z = sum(Pr,2) -Pr_mac -Pr_uav;
   % if length(Puav)==1
        %Z=7.94e-14;
    %end
    %Pn=7.94e-14;
    % Calculte MBS and UAV SIRs
    SIR_mac = Pr_mac./(Z+Pr_uav);
    SIR_uav_ue = Pr_uav./(Z+Pr_mac);
    % SIR calculation of first hop
     Z_first=sum(pr_mbs_uav,1);
    for i=1:length(pr_mbs_uav)
        SIR_mbs_uav(i)=pr_mbs_uav(i)/( Z_first-pr_mbs_uav(i));  
    end
    SIR_uav=zeros(length(Xue),1);
    for i=1:length(Xue)    
           SIR_uav(i,1)=2*SIR_uav_ue(i)*SIR_mbs_uav(idx_moi(i))/(SIR_uav_ue(i)+SIR_mbs_uav(idx_moi(i)));
    end
    %SIR_mac(SIR_mac>316.2278) = 316;
    % MBS or UAV cell selection
    idx_mue = SIR_mac > SIR_uav;
    idx_uue = SIR_mac <= SIR_uav;
    % Assuming round-robin scheduling, calculate the SEs of all the UEs
    % MUEs
    a=idx_mue==0;
    b=idx_moi_thr(a);
    idx_moi = idx_moi(idx_mue);
    SIR_mac = SIR_mac(idx_mue);
    moi_list = tabulate([-1; idx_moi]);
    moi_list(1,:) = [];
    N_mue = moi_list(:,2);
    moi_list = moi_list(:,1);
    SE_mue = zeros(size(SIR_mac));
    a=SE_mue;
    for x = 1:length(moi_list)
        c=find(x==b); % MBS is relaying data to UAV ,so we have to consider it
        d=length(c);
        idx = idx_moi == moi_list(x);
        SE_mue(idx) = log2(1+SIR_mac(idx))/(N_mue(x)+d);
        %a(idx)=SE_mue(idx);
        %SE_mue(idx) = log10(log2(1+SIR_mac(idx))/(N_mue(x)+d));
    end
    
    % UUEs
    idx_uoi = idx_uoi(idx_uue);
    SIR_uav = SIR_uav(idx_uue);
    uoi_list = tabulate([-1; idx_uoi]);
    uoi_list(1,:) = [];
    N_uue = uoi_list(:,2);
    uoi_list = uoi_list(:,1);
    SE_uue = zeros(size(SIR_uav));
    b=SE_uue;
    for x = 1:length(uoi_list)
        idx = idx_uoi == uoi_list(x);
        SE_uue(idx) = log2(1+SIR_uav(idx))/N_uue(x);
         %b(idx)=SE_uue(idx);
        %SE_uue(idx) = log10(log2(1+SIR_uav(idx))/N_uue(x));
    end

    SE = [SE_mue; SE_uue];
    size(SE);
    SE_pf=sum(SE);
    user_throughput=SE; % to calculate the throughput and fairness in absolute form
    fairness=sum(user_throughput.^2)/(length(Xue)*sum(user_throughput)^2);
    total_through=sum(user_throughput);
    %proportional_fair_throughput=log10(SE);
    max_sumrate=SE_pf;
    %save('sir.mat','SIR_mac')
end

