clc
close all
clear all
tic
%% Parameters
lambda          = 2;           % MBS density (per km^2)
lambdaUE        = 30;         % UE density (per km^2)
LenSimArea      = 2;      % Length of the simulation area (in km)
SE_Th           = 0.01;        % SE threshold (in bps/Hz)
P_mac_dBm       = 46;        %Macro Tx power (in dBm)
P_uav_dBm       = 30;          % UAV Tx power (in dBm)
K_dB            = 0;         % Attenuation due to geometrical parameters of antennas (in dB)
%PercDestroyMBS  = 90;          % percentage of MBSs to destroy
HeightMBS       = 0.030; %100 feet     % Height of the MBSs (in km)
HeightUAV1       = 0.12; %400 feet     % Height of the UAVs (in km)
% HeightUAV1      = 0.1524; %500 feet   % Height of the UAVs (in km)
% HeightUAV1      = 0.0762; % 250 feet   % Height of the UAVs (in km)
PLE             = 3;

Nm = 2; % Number of MBSs
Nue = 50; % Number of UEs
%Nue = 1;
Pm = 10^(P_mac_dBm/10)/1000 * 10^(K_dB/10); % Net transmit power in Watts
Puav = 10.^(P_uav_dBm/10)/1000* 10^(K_dB/10); % Net transmit power in Watts

%Initially generate random MBS and UE location coordinates
%within a given simulation area
for i=1:1000
Xm = LenSimArea*(rand(Nm,1));
Ym = LenSimArea*(rand(Nm,1));
%Xm2 = Xm;
%Ym2 = Ym;
Xue = LenSimArea*(rand(Nue,1));
Yue = LenSimArea*(rand(Nue,1));
Network.xm=Xm;
Network.ym=Ym;
%Network.xm2=Xm2;
%Network.ym2=Ym2;
Network.xue=Xue;
Network.yue=Yue;
save(sprintf('Network_%d',i), '-struct', 'Network');
 end