clc
close all

Outage_no_UAV=[ 0.2230 0.2042 0.1750];
Outage_3D_downtilt_MBS_4=[0.0869 0.1042 0.1267 0.1635]; % 10, 6, 2, and -2 degrees
Outage_3D_downtilt_MBS_3=[0.1235 0.1384 0.1563 0.1921]; % 10, 6, 2, and -2 degrees
Outage_3D_downtilt_MBS_2=[0.1669 0.1734 0.1877 0.2201]; % 10, 6, 2, and -2 degrees
Outage_3D= [0.1734 0.1384 0.1042]; % MBS = 2,3, and 4
Outage_2D_40m=[0.1731 0.1385 0.1043];  % MBS = 2,3, and 4;
Outage_2D_80m=[0.1713  0.1361  0.1015];  % MBS = 2,3, and 4
Outage_2D_120m=[0.1689 0.1339 0.1001]; % MBS = 2,3, and 4

%% Downtilt Dataset
downtilt_data=[Outage_3D_downtilt_MBS_2;Outage_3D_downtilt_MBS_3;Outage_3D_downtilt_MBS_4];

%% Outage 3D between antenna angles
x=1:3;
figure()
set(groot,'defaultAxesTickLabelInterpreter','latex');
plot(x,downtilt_data(:,1),'ko-','LineWidth',1.3); hold on;
plot(x,downtilt_data(:,2),'rp-','LineWidth',1.3); hold on;
plot(x,downtilt_data(:,3),'bh-','LineWidth',1.3); hold on;
plot(x,downtilt_data(:,4),'ks-','LineWidth',1.3); hold on;
xticks([1 2 3])
xticklabels({'$N_{\rm MBS}=2$','$N_{\rm MBS}=3$','$N_{\rm MBS}=4$'})

xlabel('MBS Number','FontSize',12)
ylabel('Outage probability','FontSize',12)
grid on
legend('3D trajectory (10 downtilt)', '3D trajectory (6 downtilt)','3D trajectory (2 downtilt)','3D trajectory (2 uptilt)');
set(gcf,'color','w');
set(gca,'fontsize',12)
set(gca,'LooseInset',get(gca,'TightInset'))
%% Outage 3D vs 2D
x=1:3;
figure()
set(groot,'defaultAxesTickLabelInterpreter','latex');
plot(x,Outage_3D,'ko-','LineWidth',1.3); hold on;
plot(x,Outage_2D_120m,'ks-','LineWidth',1.3); hold on;
plot(x,Outage_2D_80m,'k*-','LineWidth',1.3); hold on;
%plot(x,Outage_prob_2D_70m(1,:),'ko-','LineWidth',1.3); hold on;
%plot(x,Outage_prob_2D_60m(1,:),'kx-','LineWidth',1.3); hold on;
plot(x,Outage_2D_40m,'k^-','LineWidth',1.3); hold on;
plot(x,Outage_no_UAV,'kp-','LineWidth',1.3); hold on;
%plot(x,Outage_prob_2D_120m(:,3),'k^-','LineWidth',1.3); hold on;
xticks([1 2 3])
xticklabels({'$N_{\rm MBS}=2$','$N_{\rm MBS}=3$','$N_{\rm MBS}=4$'})
set(gcf,'color','w');
set(gca,'fontsize',12)
%xticklabels({'$N_{\rm MBS}=2$','$N_{\rm MBS}=3$','$N_{\rm MBS}=4$'})
xlabel('MBS Number','FontSize',12)
ylabel('Outage probability','FontSize',12)
grid on
legend('3D trajectory', '2D trajectory 120 m','2D trajectory 80 m','2D trajectory 40 m','No UAV');

set(gcf,'color','w');
set(gca,'fontsize',12)
set(gca,'LooseInset',get(gca,'TightInset'))