clc
close all
clear all
%% Parameters
lambda          = 4;           % MBS density (per km^2)
lambdaUE        = 50;         % UE density (per km^2)
LenSimArea      = 2;      % Length of the simulation area (in km)
K_dB            = 0;         % Attenuation due to geometrical parameters of antennas (in dB)
HeightMBS       = 0.030;    % Height of the MBSs (in km)
%HeightUAV1       = 0.12;      % Height of the UAVs (in km)
%LenSimArea      = 3;      % Length of the simulation area (in km)
P_mac_dBm       = 46;        %Macro Tx power (in dBm)
P_uav_dBm       = 30;          % UAV Tx power (in dBm)
Pm = 10^(P_mac_dBm/10)/1000 * 10^(K_dB/10); % Net transmit power in Watts
Puav = 10.^(P_uav_dBm/10)/1000* 10^(K_dB/10); % Net transmit power in Watts
PLE=3;
Nm = 2; % Number of MBSs
Nue = 50; % Number of UEs
%Nm = round(lambda*LenSimArea^2); % Number of MBSs
%Nue = round(lambdaUE*(LenSimArea)^2); % Number of UEs
Zuav=.04:.01:.12; % UAV height in KM
%Zuav_range=[0.04 0.08 .12]; % UAV height in KM
tc=.05;% outage threshold
T_max=30; %Maximum flight duration
b = LenSimArea;
grid_size=.1;
Res =-0.1:grid_size:b+0.1;                  % Layout grid resolution
neighbor=1;
end_point=b*[1 1];
start_point=b*[0 0];
size_grid=length(Res);
start_point_trans=trans(start_point);
end_point_trans=trans(end_point);
max_throughput_harmonic_antenna=single(zeros(size_grid,size_grid));
path1='C:\PhD Research\3D Trajectory Research\IEEE Transaction on Aerospace\New_outage_simulator_sep13\network\MBS_4';
addpath(path1)
for ii = 1:1000
Network=load(['Network_' num2str(ii) '.mat']);
%Xm = LenSimArea*(rand(Nm,1));Ym = LenSimArea*(rand(Nm,1));Xue = LenSimArea*(rand(Nue,1));Yue = LenSimArea*(rand(Nue,1));
Xm=Network.xm;Ym=Network.ym;Xue=Network.xue;Yue=Network.yue;
Zm = HeightMBS*ones(size(Xm));Zue=.002*ones(size(Xue));
[elev,azi]=angle_calculation(Xm,Ym,Zm,Xue,Yue,Zue);
dbstop if error    
%% Antenna Gain vector
theta_s= -2; % 12 degree electrical downtilt
phi_s= 0;
gain_vector=zeros(1,length(Xue)*length(Xm));

elev=elev(:);azi=azi(:);
 for i=1:length(gain_vector)
    [gain_vector(i),~]=radiation_rebato(elev(i),azi(i),theta_s);
 end
%disp(gain_vector)
gain_vector=reshape(gain_vector,length(Xue),length(Xm));
%% Results with No UAV to campare with UAV deployment
max_noUAV=(maxsumrate_noUAV(Xm, Ym, Zm, Xue, Yue, Pm,gain_vector));
%% Proportional Fairness Throughput calculation at each node with antenna radiation pattern and height
%gain=zeros(size_grid);
for i=-.1:grid_size:Res(end)
        for j=-.1:grid_size:Res(end)
            %if  (~(i==start_point_trans(1) && j==start_point_trans(2)))
            %point_current=[i,j];
            nx=trans(i);
            ny=trans(j);
            for k=1:length(Zuav)
                [~,a]=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue,Zue, Pm, i,j , Zuav(k), Puav,gain_vector,theta_s); 
                 max_throughput_harmonic_antenna(nx,ny,k)=sum(a);
                %max_throughput_harmonic_antenna(nx,ny)=sum(a);
                %max_throughput_harmonic_antenna(nx,ny,k)= maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue,Zue, Pm, i,j , Zuav(k), Puav,gain_vector);              
            end
        end
end



%% Trajectory Optimization using 3D Dynamic Programming

%Traject_backhaul_3D_antenna_max=dynamic_3D(max_throughput_harmonic_antenna,T_max,start_point_trans,end_point_trans,Zuav);
Traject_backhaul_3D_antenna_max=dynamic_3D_efficient(max_throughput_harmonic_antenna,T_max,start_point_trans,end_point_trans,Zuav);
%sum(max_throughput_harmonic_antenna(Traject_backhaul_3D_antenna_max));

Traject_backhaul_3D_antenna_max(1:end,1:2)=1*(Traject_backhaul_3D_antenna_max(1:end,1:2)-2)./(10);
for i=1:length(Traject_backhaul_3D_antenna_max)
    %Traject_proportional_3D(i,3)=Zuav(Traject_proportional_3D(i,3));
    Traject_backhaul_3D_antenna_max(i,3)=Zuav(Traject_backhaul_3D_antenna_max(i,3));
   % Traject_backhaul_3D_antenna_fifth(i,3)=Zuav(Traject_backhaul_3D_antenna_fifth(i,3));
end
%% Outage calculation
outage_max_3D=zeros(1,size(Traject_backhaul_3D_antenna_max,1));
for i=1:size(Traject_backhaul_3D_antenna_max,1)
    % Calculationg Throughput of each UE using both Trajectories
   %[ ~,user_pf_2D]=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue, Zue,Pm, Traject_proportional_2D(i,1),Traject_proportional_2D(i,2), Zuav, Puav,gain_vector);
   [ ~,user_max_3D]=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue, Zue,Pm, Traject_backhaul_3D_antenna_max(i,1),Traject_backhaul_3D_antenna_max(i,2), Traject_backhaul_3D_antenna_max(i,3), Puav,gain_vector,theta_s);
    %outage_pf_idx_2D=find(user_pf_2D<tc);
    %outage_pf_2D(i)=length(outage_pf_idx_2D)/length(Xue);
    outage_max_idx_3D=find(user_max_3D<tc);
    outage_max_3D(i)=length(outage_max_idx_3D)/length(Xue); 
end
outage_max_avg_3D(ii)=mean(outage_max_3D);
ii
%% Results with No UAV to campare with UAV deployment
[~,user_maxnoUAV]=(maxsumrate_noUAV(Xm, Ym, Zm, Xue, Yue, Pm,gain_vector));
%[PF_noUAV,user_PFnoUAV]=(PFrate_noUAV(Xm, Ym, Zm, Xue, Yue, Pm,gain_vector));
outage_noUAV_idx=find(user_maxnoUAV<tc);
outage_noUAV(ii)=length(outage_noUAV_idx)/length(Xue);

%save(sprintf('Traject_max_sum_3D%d',ii), 'Traject_backhaul_3D_antenna_max');    
end
outage_prob_max_3D=mean(outage_max_avg_3D);
outage_prob_noUAV=mean(outage_noUAV)
outage_prob_max_3D