clc
close all
clear all
datestr(now, 'HH:MM:SS')
tic
%% Parameters
% lambda          = 4;           % MBS density (per km^2)
% lambdaUE        = 100;         % UE density (per km^2)
 LenSimArea      = 1;      % Length of the simulation area (in km)
% SE_Th           = 0.01;        % SE threshold (in bps/Hz)
P_mac_dBm       = 46;        %Macro Tx power (in dBm)
P_uav_dBm       = 30;          % UAV Tx power (in dBm)
K_dB            = 0;         % Attenuation due to geometrical parameters of antennas (in dB)
%PercDestroyMBS  = 90;          % percentage of MBSs to destroy
HeightMBS       = 0.030;    % Height of the MBSs (in km)
HeightUAV1       = 0.12;      % Height of the UAVs (in km)
% HeightUAV1      = 0.1524; %500 feet   % Height of the UAVs (in km)
% HeightUAV1      = 0.0762; % 250 feet   % Height of the UAVs (in km)
%PLE             = 4;
%Nm = round(lambda*LenSimArea^2); % Number of MBSs
%Nue = round(lambdaUE*(LenSimArea)^2); % Number of UEs
%Nue = 1;
Pm = 10^(P_mac_dBm/10)/1000 * 10^(K_dB/10); % Net transmit power in Watts
Puav = 10.^(P_uav_dBm/10)/1000* 10^(K_dB/10); % Net transmit power in Watts
%rng('default') % to generate same random number 
% Initially generate random MBS and UE location coordinates
% within a given simulation area
% Xm = LenSimArea*(rand(Nm,1));
% Ym = LenSimArea*(rand(Nm,1));
% Xue = LenSimArea*(rand(Nue,1));
% Yue = LenSimArea*(rand(Nue,1));
% Xm =(cell2mat(struct2cell(load('Xbs.mat'))));
% Ym = (cell2mat(struct2cell(load('Ybs.mat'))));
% Xue = (cell2mat(struct2cell(load('Xuser.mat'))));
% Yue = (cell2mat(struct2cell(load('Yuser.mat'))));
% save('Xbs.mat','Xm') 
% save('Ybs.mat','Ym') 
% save('Xuser.mat','Xue') 
% save('Yuser.mat','Yue') 
% %mission_points=.7*LenSimArea*(rand(2,2)-0.5);
%  Xm=[0;1];
%  Ym=[.5;0.5];
 %Xue=[.1;.5];Yue=[.9;.5];
%Zm = HeightMBS*ones(size(Xm));

T_max=30; %Maximum flight duration
b = LenSimArea;
grid_size=.1;
Res =-.1:grid_size:b+.1;                  % Layout grid resolution
neighbor=1;
end_point=b*[1 1];
start_point=b*[0 0];
size_grid=length(Res);
%% You may need to change the below path according to your workstation  location
addpath ('C:\PhD Research\3D Trajectory Research\IEEE Transaction on Aerospace\SE Gain Calculation\MBS_4');
for ii = 1:1000
Network=load(['Network_' num2str(ii) '.mat']);
Xm=Network.xm;Ym=Network.ym;Xue=Network.xue;Yue=Network.yue;Zm = HeightMBS*ones(size(Xm));
Zue=.002*ones(size(Xue));
Zm = HeightMBS*ones(size(Xm));
Zuav=.04:.01:.12;
%% point traslations
start_point_trans=trans(start_point);
end_point_trans=trans(end_point);
Proportional_throughput_harmonic_antenna=single(zeros(size_grid,size_grid,length(Zuav)));
%Proportional_throughput_harmonic_antenna_2D=Proportional_throughput_harmonic_antenna;
max_throughput_harmonic_antenna=Proportional_throughput_harmonic_antenna;
%max_throughput_harmonic_antenna_2D=Proportional_throughput_harmonic_antenna;
fifth_throughput_harmonic_antenna=Proportional_throughput_harmonic_antenna;
%fifth_throughput_harmonic_antenna_2D=Proportional_throughput_harmonic_antenna;
%% Angle Calculation
% angles of ues from their respective MBSs
% vargin=0 for UE angle calculation and vargin=1 for UAV angle calculation
%vargin=0;Xuav=0;Yuav=0;
%[elev_uav,azi_uav]=angle_calculation(Xm,Ym,Zm,Xue,Yue,Zue,Xuav,Yuav,Zuav)
% Without UAV
[elev,azi]=angle_calculation(Xm,Ym,Zm,Xue,Yue,Zue);
dbstop if error
%% Antenna Gain vector
theta_s=0; % 12 degree electrical downtilt
phi_s=0;
gain_vector=zeros(1,length(Xue)*length(Xm));
elev=elev(:);azi=azi(:);
 for i=1:length(gain_vector)
    [gain_vector(i),~]=radiation_rebato(elev(i),azi(i),theta_s);
 end
%plot(gain_vector)
gain_vector=reshape(gain_vector,length(Xue),length(Xm));
%% Proportional Fairness Throughput calculation at each node with antenna radiation pattern
%gain=zeros(size_grid);
for i=-.1:grid_size:Res(end)
        for j=-.1:grid_size:Res(end)
            %if  (~(i==start_point_trans(1) && j==start_point_trans(2)))
            %point_current=[i,j];
            nx=trans(i);
            ny=trans(j) ;
            for k=1:length(Zuav)
                %Proportional_throughput_harmonic_antenna(nx,ny,k)= PF_throughput_harmonic(Xm, Ym, Zm, Xue, Yue, Zue,Pm, i,j , Zuav(k), Puav,gain_vector);
                max_throughput_harmonic_antenna(nx,ny,k)= maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue,Zue, Pm, i,j , Zuav(k), Puav,gain_vector,theta_s);
                %fifth_throughput_harmonic_antenna(nx,ny,k)= fifth_rate_harmonic(Xm, Ym, Zm, Xue, Yue,Zue, Pm, i,j , Zuav(k), Puav,gain_vector);
            end
        end
end

%% 2D Proportional throughput , Max min thorughput and 5pSE throughput
twoD_height=find(abs(Zuav-.12)<.0001);
%Proportional_throughput_harmonic_antenna_2D= Proportional_throughput_harmonic_antenna(:,:,twoD_height);
max_throughput_harmonic_antenna_2D= max_throughput_harmonic_antenna(:,:,twoD_height);
%fifth_throughput_harmonic_antenna_2D= fifth_throughput_harmonic_antenna(:,:,twoD_height);


%% Trajectory Optimization using 3D Dynamic Programming
%Traject_backhaul_3D_antenna_PF=dynamic_3D(Proportional_throughput_harmonic_antenna,T_max,start_point_trans,end_point_trans,Zuav);
Traject_backhaul_3D_antenna_max=dynamic_3D(max_throughput_harmonic_antenna,T_max,start_point_trans,end_point_trans,Zuav);
%Traject_backhaul_3D_antenna_fifth=dynamic_3D(fifth_throughput_harmonic_antenna,T_max,start_point_trans,end_point_trans,Zuav);
%Traject_backhaul_3D_antenna_PF(1:end,1:2)=LenSimArea*(Traject_backhaul_3D_antenna_PF(1:end,1:2)-2)./(10);
Traject_backhaul_3D_antenna_max(1:end,1:2)=LenSimArea*(Traject_backhaul_3D_antenna_max(1:end,1:2)-2)./(10);
%Traject_backhaul_3D_antenna_fifth(1:end,1:2)=LenSimArea*(Traject_backhaul_3D_antenna_fifth(1:end,1:2)-2)./(10);
for i=1:length(Traject_backhaul_3D_antenna_max)
   % Traject_backhaul_3D_antenna_PF(i,3)=Zuav(Traject_backhaul_3D_antenna_PF(i,3));
    Traject_backhaul_3D_antenna_max(i,3)=Zuav(Traject_backhaul_3D_antenna_max(i,3));
    %Traject_backhaul_3D_antenna_fifth(i,3)=Zuav(Traject_backhaul_3D_antenna_fifth(i,3));
end
%% Trajectory Optimization using 2D Dynamic Programming
%Traject_backhaul_2D_antenna_PF=dynamic(Proportional_throughput_harmonic_antenna_2D,T_max,start_point_trans,end_point_trans);
%Traject_backhaul_2D_antenna_max=dynamic(max_throughput_harmonic_antenna_2D,T_max,start_point_trans,end_point_trans);
%Traject_backhaul_2D_antenna_fifth=dynamic(fifth_throughput_harmonic_antenna_2D,T_max,start_point_trans,end_point_trans);
%Traject_backhaul_2D_antenna_PF=LenSimArea*(Traject_backhaul_2D_antenna_PF-2)./(10);
%Traject_backhaul_2D_antenna_max=LenSimArea*(Traject_backhaul_2D_antenna_max-2)./(10);
%Traject_backhaul_2D_antenna_fifth=LenSimArea*(Traject_backhaul_2D_antenna_fifth-2)./(10);

%save(sprintf('Traject_backhaul_3D_antenna_PF_%d',ii), 'Traject_backhaul_3D_antenna_PF');
save(sprintf('Traject_backhaul_3D_antenna_max_%d',ii), 'Traject_backhaul_3D_antenna_max');
%save(sprintf('Traject_backhaul_3D_antenna_fifth_%d',ii), 'Traject_backhaul_3D_antenna_fifth');
%save(sprintf('Traject_backhaul_2D_antenna_PF_%d',ii), 'Traject_backhaul_2D_antenna_PF');
%save(sprintf('Traject_backhaul_2D_antenna_max_%d',ii), 'Traject_backhaul_2D_antenna_max');
%save(sprintf('Traject_backhaul_2D_antenna_fifth_%d',ii), 'Traject_backhaul_2D_antenna_fifth');
%save(sprintf('Traject_proportional_antennaVH_%d',ii), 'Traject_proportional_antennaVH');
%save(sprintf('Traject_proportional_%d',ii), 'Traject_proportional_antenna');
%save(sprintf('Traject_max_sum%d',ii), 'Traject_maxsum_antenna');
%save(sprintf('Traject_fifth%d',ii), 'Traject_fifth_antenna');
%save('C:\PhD Research\Trajectory optimization\Trajectory Optimization_RWW_2018_v2\Trajectory Optimization_RWW_2018\Network3\optimal_traject_25s.mat','Traject_proportional') 
%% Calculating Optimum Point of the MAP
% Proportional_throughput_antenna
% [~,ind]=max(Proportional_throughput_antenna(:));
% [X_opt,Y_opt]=ind2sub(size(Proportional_throughput_antenna),ind);
% X_opt=LenSimArea*(X_opt-2)./(10);
% Y_opt=LenSimArea*(Y_opt-2)./(10);
% optimal_point=[X_opt,Y_opt];
% disp(optimal_point)
% % Proportional_throughput_realPl
% [~,ind]=max(Proportional_throughput_relaistic(:));
% [X_opt,Y_opt]=ind2sub(size(Proportional_throughput_relaistic),ind);
% X_opt=LenSimArea*(X_opt-1)./(size_grid-1);
% Y_opt=LenSimArea*(Y_opt-1)./(size_grid-1);
% optimal_point=[X_opt,Y_opt];
% disp(optimal_point)
% 
% % Proportional_throughput_relay
% [~,ind]=max(Proportional_throughput_relay(:));
% [X_opt,Y_opt]=ind2sub(size(Proportional_throughput_relay),ind);
% X_opt=LenSimArea*(X_opt-1)./(size_grid-1);
% Y_opt=LenSimArea*(Y_opt-1)./(size_grid-1);
% optimal_point=[X_opt,Y_opt];
% disp(optimal_point)
% % Proportional_throughput_combined
% [~,ind]=max(Proportional_throughput_combined(:));
% [X_opt,Y_opt]=ind2sub(size(Proportional_throughput_combined),ind);
% X_opt=LenSimArea*(X_opt-1)./(size_grid-1);
% Y_opt=LenSimArea*(Y_opt-1)./(size_grid-1);
% optimal_point=[X_opt,Y_opt];
% disp(optimal_point)

%% Plotting the optimal trajectory

% x1=Traject_proportional_antenna(1:length(Traject_proportional_antenna));
% y1=Traject_proportional_antenna(length(Traject_proportional_antenna)+1:end);
% x2=Traject_proportional_realistic(1:length(Traject_proportional_realistic));
% y2=Traject_proportional_realistic(length(Traject_proportional_realistic)+1:end);
% x3=Traject_proportional_relay(1:length(Traject_proportional_relay));
% y3=Traject_proportional_relay(length(Traject_proportional_relay)+1:end);
% x4=Traject_proportional_combined(1:length(Traject_proportional_combined));
% y4=Traject_proportional_combined(length(Traject_proportional_combined)+1:end);
% figure()
% min_x = -0.1;
% max_x = 1.1;
% min_y = -0.1;
% max_y = 1.1;
% sir_db=SIR_plot(Xm,Ym,Zm);
% %sir_db =(cell2mat(struct2cell(load('sir.mat'))));
% imagesc([min_x max_x], [min_y max_y],sir_db'); % taking transpose as (0,0)in grid --> (1,1) in matrix
% colormap(flipud(summer))
% h = colorbar;
% ylabel(h, 'SIR (dB)')
% hold on;
% plot(x1,y1,'k-','LineWidth',1.4);hold on;
% %plot(x1,y1,'kx-','LineWidth',1.4);hold on;
% % plot(x2,y2,'r^--','LineWidth',1.4);hold on;
% % plot(x3,y3,'bo--','LineWidth',1.4);
% % plot(x4,y4,'kd--','LineWidth',1.4);
% plot(Xm,Ym,'kp','MarkerSize',6,'LineWidth',2); hold on;
% plot(Xue,Yue,'or','MarkerSize',2,'LineWidth',2);
% set(gca,'ydir','normal'); 
% xlabel('X-axis distance (Km)','FontSize',12);
% ylabel('Y-axis distance (Km)','FontSize',12);
% %yticks([0 .2 .4 .6 .8 1])
% legend('PF Trajectory antenna orientation','MBS','UE ','Location','northwest','Orientation','vertical');
% %print -depsc2 traject_sir_map.eps;
% rectangle('Position',[0 0 1 1])
% Plot smoothing using bezier curve
% figure (2)
% imagesc([min_x max_x], [min_y max_y],sir_db'); % taking transpose as (0,0)in grid --> (1,1) in matrix
% colormap(flipud(summer))
% h = colorbar;
% ylabel(h, 'SIR (dB)')
% hold on;
% plot(x1,y1,'b-','LineWidth',1.4);hold on;
% plot(Xm,Ym,'kp','MarkerSize',6,'LineWidth',1.6); hold on;
% plot(Xue,Yue,'or','MarkerSize',2,'LineWidth',2);
% set(gca,'ydir','normal'); 
% a=bezier_(Traject_proportional_antenna, T_max, [],3);
% hold on
% xlim([0 1])
% ylim([0 1])
% plot(a(1:length(a)),a(length(a)+1:end),'ko-','MarkerIndices',1:1:length(a),'MarkerSize',5,'LineWidth',1.6)
%  legend('5pSE Trajectory antenna orientation','MBS','UE ','Smooth Trajectory','Location','northwest','Orientation','vertical');
end
toc
