clc
close all
clear all


%% Results with 6 degree downtilt angle
se_gain_3D_6=[29.8002 24.0222 22.3342];
%se_gain_3D_6=[24.0501 18.7867 17.3852];
se_gain_2D_120=[16.98 12.7183 13.0099];
se_gain_2D_100=[18.8192 14.1982 13.8648];
se_gain_2D_80=[21.3824 16.431 15.4124];
se_gain_2D_70=[24.4289 18.4386 15.4601];
se_gain_2D_60=[24.4319 17.4495 14.785];
se_gain_2D_40=[19.1578 14.1150 12.1102];

%% Results with 12 degree downtilt angle

se_gain_3D_12=[25.5495 19.2209 16.1562];
se_gain_2D_120_12=[16.063 12.1133 10.6414];
se_gain_2D_100_12=[17.8364 13.6648 11.9044];
se_gain_2D_80_12=[21.5142 16.2994 13.9172];

y_max_2=[30.4230 17.6535 15.4240 20.5536];
y_max_3=[21.1452 13.2239 11.6743 15.0527];
y_max_4=[16.5898 10.8991 10.4116 12.2888];
y_max=[y_max_2;y_max_3;y_max_4];
y_12=[[se_gain_3D_12' se_gain_2D_120_12' se_gain_2D_100_12' se_gain_2D_80_12'];];
y_6=[se_gain_3D_6' se_gain_2D_120' se_gain_2D_100' se_gain_2D_80'];
diff=y_12-y_6
% set(groot,'defaultAxesTickLabelInterpreter','latex');
% bar(y_6);ylim([0 30]);
% xticklabels({'$N_{\rm MBS}=2$','$N_{\rm MBS}=3$','$N_{\rm MBS}=4$'})
% xlabel('MBS Number','FontSize',12)
% ylabel('SE Gain (in %) over no UAV','FontSize',12)
% 
% h=legend('3D trajectory', '2D trajectory with 120 m height','2D trajectory with 100 m height','2D trajectory with 80 m height');
% 
% 
%% Plotting Graph
figure()
set(groot,'defaultAxesTickLabelInterpreter','latex');
plot(se_gain_3D_6,'k--','LineWidth',1.3); hold on;
plot(se_gain_2D_120,'ks-','LineWidth',1.3); hold on;
plot(se_gain_2D_80,'k*-','LineWidth',1.3); hold on;
plot(se_gain_2D_70,'ko-','LineWidth',1.3); hold on;
plot(se_gain_2D_60,'kx-','LineWidth',1.3); hold on;
plot(se_gain_2D_40,'k^-','LineWidth',1.3); hold on;
xticks([1 2 3])
xticklabels({'$N_{\rm MBS}=2$','$N_{\rm MBS}=3$','$N_{\rm MBS}=4$'})
%xticklabels({'$N_{\rm MBS}=2$','$N_{\rm MBS}=3$','$N_{\rm MBS}=4$'})
xlabel('MBS Number','FontSize',12)
ylabel('SE Gain (in %) over no UAV','FontSize',12)
grid on
legend('3D trajectory', '2D trajectory 120 m','2D trajectory 80 m','2D trajectory 70 m','2D trajectory 60 m','2D trajectory 40 m');

