clc
%close all
clear all
%% USE THIS FILE FOR OBTAINING THE OPTIMAL 2D HEIGHT
path2='C:\PhD Research\3D Trajectory Research\IEEE Transaction on Aerospace\SE Gain Calculation\MBS_2';
addpath(path2)
%% Parameters
lambda          = 3;           % MBS density (per km^2)
lambdaUE        = 100;         % UE density (per km^2)
LenSimArea      = 1;      % Length of the simulation area (in km)
K_dB            = 0;         % Attenuation due to geometrical parameters of antennas (in dB)
HeightMBS       = 0.030;    % Height of the MBSs (in km)
%HeightUAV1       = 0.12;      % Height of the UAVs (in km)
LenSimArea      = 1;      % Length of the simulation area (in km)
P_mac_dBm       = 46;        %Macro Tx power (in dBm)
P_uav_dBm       = 30;          % UAV Tx power (in dBm)
Pm = 10^(P_mac_dBm/10)/1000 * 10^(K_dB/10); % Net transmit power in Watts
Puav = 10.^(P_uav_dBm/10)/1000* 10^(K_dB/10); % Net transmit power in Watts
PLE=3;
Nm = round(lambda*LenSimArea^2); % Number of MBSs
Nue = round(lambdaUE*(LenSimArea)^2); % Number of UEs
Zuav=.04:.02:.12; % UAV height in KM
tc=.01;% outage threshold
T_max=30; %Maximum flight duration
b = LenSimArea;
grid_size=.1;
Res =-.1:grid_size:b+.1;                  % Layout grid resolution
neighbor=1;
end_point=b*[1 1];
start_point=b*[0 0];
size_grid=length(Res);
start_point_trans=trans(start_point);
end_point_trans=trans(end_point);
max_throughput_harmonic_antenna=single(zeros(size_grid,size_grid));
gain=zeros(1,100);SE_height=zeros(1,length(Zuav));
for jj=1:length(Zuav)
for ii = 1:100
%Xm = LenSimArea*(rand(Nm,1));Ym = LenSimArea*(rand(Nm,1));
%Xue = LenSimArea*(rand(Nue,1));Yue = LenSimArea*(rand(Nue,1));
Network=load(['Network_' num2str(ii) '.mat']);
Xm=Network.xm;Ym=Network.ym;Xue=Network.xue;Yue=Network.yue;
Zm = HeightMBS*ones(size(Xm));Zue=.002*ones(size(Xue));

[elev,azi]=angle_calculation(Xm,Ym,Zm,Xue,Yue,Zue);
dbstop if error

%% Antenna Gain vector
theta_s=6; % 12 degree electrical downtilt
phi_s=0;
gain_vector=zeros(1,length(Xue)*length(Xm));

elev=elev(:);azi=azi(:);
 for i=1:length(gain_vector)
    [gain_vector(i),~]=radiation_rebato(elev(i),azi(i),theta_s);
 end
%disp(gain_vector)
gain_vector=reshape(gain_vector,length(Xue),length(Xm));
%% Results with No UAV to campare with UAV deployment
max_noUAV=(maxsumrate_noUAV(Xm, Ym, Zm, Xue, Yue, Pm,gain_vector));
%% Proportional Fairness Throughput calculation at each node with antenna radiation pattern and height
%gain=zeros(size_grid);
for i=-.1:grid_size:Res(end)
        for j=-.1:grid_size:Res(end)
            %if  (~(i==start_point_trans(1) && j==start_point_trans(2)))
            %point_current=[i,j];
            nx=trans(i);
            ny=trans(j);
            %for k=1:length(Zuav)  
                 max_throughput_harmonic_antenna(nx,ny)=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue,Zue, Pm, i,j , Zuav(jj), Puav,gain_vector,theta_s); 
                %max_throughput_harmonic_antenna(nx,ny)=sum(a);
                %max_throughput_harmonic_antenna(nx,ny,k)= maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue,Zue, Pm, i,j , Zuav(k), Puav,gain_vector);              
            %end
        end
end



%% Trajectory Optimization using 3D Dynamic Programming

%Traject_backhaul_3D_antenna_max=dynamic_3D(max_throughput_harmonic_antenna,T_max,start_point_trans,end_point_trans,Zuav);
Traject_backhaul_2D_antenna_max=dynamic(max_throughput_harmonic_antenna,T_max,start_point_trans,end_point_trans);
%sum(max_throughput_harmonic_antenna(Traject_backhaul_3D_antenna_max));

Traject_backhaul_2D_antenna_max(1:end,1:2)=LenSimArea*(Traject_backhaul_2D_antenna_max(1:end,1:2)-2)./(10);
%% Plotting


x2 = Traject_backhaul_2D_antenna_max(1:length(Traject_backhaul_2D_antenna_max));
y2 = Traject_backhaul_2D_antenna_max(length(Traject_backhaul_2D_antenna_max)+1:2*length(Traject_backhaul_2D_antenna_max));
%z2 = Traject_backhaul_2D_antenna_max(2*T_max+1:end);
% 
% for i=1:length(Traject_backhaul_2D_antenna_max)
%     %Traject_backhaul_3D_antenna_PF(i,3)=Zuav(Traject_backhaul_3D_antenna_PF(i,3));
%     Traject_backhaul_2D_antenna_max(i,3)=Zuav(Traject_backhaul_2D_antenna_max(i,3));
%    % Traject_backhaul_3D_antenna_fifth(i,3)=Zuav(Traject_backhaul_3D_antenna_fifth(i,3));
% end

%% Gain calculation
for i= 1:length(Traject_backhaul_2D_antenna_max)
    th(i)=maxsum_throughput_harmonic(Xm, Ym, Zm, Xue, Yue, Zue,Pm, Traject_backhaul_2D_antenna_max(i,1), Traject_backhaul_2D_antenna_max(i,2), Zuav(jj), Puav,gain_vector,theta_s);
end

max_noUAV=max_noUAV/length(Xue);
uav_per_ue_gain=mean(th)/length(Xue);
gain(ii)=100*(uav_per_ue_gain-max_noUAV)/max_noUAV;
%dbstop if gain(ii)<=0
ii
end
SE_height(jj)=mean(gain);
end
disp(mean(gain))
%save('optimal_height_mbs2_30s.mat','SE_height')
figure()
plot(Zuav*1000,100*SE_height,'k--','LineWidth',1.3)
xlabel('UAV height (m)','FontSize',12)
ylabel('SE gain (in %) over no UAV','FontSize',12)
grid on